<template>
  <div style="height:100%">
    
    <div class='main_view'>
        
        <div class='daytime_block'>
            <transition-group name="daytime-animations">
                <div class='daytime' 
                v-for='daytime in daytimeList' 
                :key='daytime.state'
                v-if='daytime.state == dayTime'
                :class='"daytime__" + daytime.state'></div>
            </transition-group>
        </div>
        <div class="clouds_block">
            <div class='clouds_layer'
            v-bind:style='getClodAnim'
            ></div>
            <div class='clouds_layer clouds_layer__paralax' 
            v-bind:style='getClodAnimP'></div>
        </div>

        <div class='wearmen_block'>
            <transition-group  name="wearmen-animations" tag="div">
                <img :src='"/img/wearset/" + slide.wear' 
                :key='"slide" + slide.id'
                v-if='slide.show'
                v-for='(slide, index) in slidesWearing'>
            </transition-group>
        </div>

        <div class='main_view__top_navigation'>
            <v-btn text class="transperent_button" dark @click='drawerChange'>
                <v-icon >mdi-menu</v-icon>
            </v-btn>


            <v-speed-dial 
            top
            absolute
            right
            direction='bottom'
            class='sped_dial_time_choser'
            v-model='dayTimeChose'>
                <v-btn 
                text 
                dark
                class="transperent_button right"
                slot="activator"
                v-model="dayTimeChose"
                >
                    Сегодня<br>
                    {{dayTimeSingular}}
                </v-btn>

                <v-btn
                    class="transperent_button button_list"
                    dark
                    small
                    text
                    
                    v-for='time in daytimeList'
                    :key='time.state'
                    @click="selectTime(time.state)"
                    v-html='time.name'
                >
                    
                </v-btn>
                
            </v-speed-dial>
            
        </div>
        
    </div>
    <carousel
    class="main_slider"
    :perPage='1'
    :paginationPadding='4'
    :paginationSize='7'
    >
        <slide>
            <div class="slide_frame">
                <span class='slide_title'>Места</span>
                <div class="slider_contetn">
                    <v-container fluid grid-list-lg>
                        <v-layout row wrap>
                            <v-flex xs6 
                            v-for='(chunk, index) in chunkPlaces'
                            :key='"chunk"+index'
                            >
                                <div
                                v-for=' (item, itemIndex) in chunk' 
                                :key='"item"+itemIndex'
                                class="slide_card" @click="openRoute(item)">
                                    <div class='slider_card__type'>
                                        <img class='card_icon' :src='item.icon_type'></svg>
                                        {{item.type}}
                                    </div>
                                    <div class='slider_card__name'>
                                        {{item.name}}
                                    </div>
                                    <v-divider></v-divider>
                                    <div class='slider_card__adress' v-html="item.address"></div>
                                </div>
                            </v-flex>
                        </v-layout>
                    </v-container>
                    
                </div>
            </div>
        </slide>
        <slide>
            <div class="slide_frame">
                <span class='slide_title'>Погода</span>
                <v-container fluid grid-list-lg>
                        <v-layout row wrap>
                            <v-flex xs6>
                                <div class="slide_card" v-if='weather.bright'>
                                    <div class='slider_card__type'>
                                        <img class='card_icon' src='/img/weather/shining-sun.svg'></svg>
                                        {{weather.bright.name}}
                                    </div>
                                    <v-divider></v-divider>
                                    <div class='slider_card__name'>{{weather.bright.description}}</div>
                                </div>
                                <div class="slide_card" v-if='weather.wind'>
                                    <div class='slider_card__type'>
                                        <img class='card_icon' src='/img/weather/wind.svg'></svg>
                                        <template v-if='weather.wind.name.length>0'>
                                            {{weather.wind.name}}
                                        </template>
                                        <template v-else>
                                            {{ getWindName(weather.wind.value) }}
                                        </template>
                                    </div>
                                    <v-divider></v-divider>
                                    <div class='slider_card__name'>
                                        
                                        <template v-if='weather.wind.description.length>0'>
                                            {{weather.wind.description}}
                                        </template>
                                        <template v-else>
                                            {{ getWindDesc(weather.wind.value) }}
                                        </template>
                                    </div>
                                </div>
                                
                            </v-flex>
                            <v-flex xs6>
                                <div class="slide_card"  v-if='weather.temperature'>
                                    <div class='slider_card__type'>
                                        <img class='card_icon' src='/img/weather/joyful.svg'></svg>
                                        {{weather.temperature.name}}
                                    </div>
                                    <v-divider></v-divider>
                                    <div class='slider_card__name'>{{weather.temperature.description}}</div>
                                </div>
                            </v-flex>
                        </v-layout>
                    </v-container>
            </div>
        </slide>
        <slide>
            <div class="slide_frame">
                <span class='slide_title'>Одежда</span>
                <v-container fluid grid-list-lg>
                        <v-layout row wrap>
                            <v-flex xs6
                            v-for='(chunk, index) in chunkWear'
                            :key='"wearchunk"+index'
                            >
                                <div class="slide_card"
                                v-for=' (item, itemIndex) in chunk' 
                                :key='"itemwear"+itemIndex'
                                >
                                    <div class='slider_card__type'>
                                        <img class='card_icon' :src='`/img/wear_icon/${item.icon}.svg`'>
                                        {{item.name}}
                                    </div>
                                    <template v-if='item.description.length'>
                                        <v-divider></v-divider>
                                        <div class='slider_card__name'>
                                            {{item.description}}
                                        </div>
                                    </template>
                                </div>
                            </v-flex>
                        </v-layout>
                    </v-container>
            </div>
        </slide>
        <slide>
            <div class="slide_frame ">
                <span class='slide_title'>Карта</span>
                <div class="here-map-frame">
                    <here-map></here-map>
                </div>
            </div>
        </slide>
    </carousel>
    <v-dialog
        v-model="dialog"
        fullscreen
        hide-overlay
        transition="dialog-bottom-transition"
        scrollable
        v-touch="{
            down: () => closeRoute
        }"
      >
        <v-card tile>
            <here-map-full 
            v-if='dialog'
            :destenation='destenation'
            v-model="dialog"
            ></here-map-full>
        </v-card>
    </v-dialog>
</div>
</template>

<script>
import _ from "lodash";
import { Carousel, Slide } from 'vue-carousel';
import HereMap from "@/components/here-map";
import HereMapFull from "@/components/here-map-full.vue";
import { DateTime } from "luxon";

export default {
  components:{ Carousel, Slide, HereMap, HereMapFull },
  data(){
    return {
      dialog:false,
      dayTimeChose: false,
      destenation: {},
      slidesWearing:[
      ],
      daytimeList:[
        {
          'name': 'Утро',
          'plural': 'Утром',
          'state': 'morning'
        },
        {
          'name': 'День',
          'plural': 'Днем',
          'state': 'day'
        },
        {
          'name': 'Вечер',
          'plural': 'Вечером',
          'state': 'evening'
        },
        {
          'name': 'Ночь',
          'plural': 'Ночью',
          'state': 'night'
        }
      ]
    }
  },
    computed:{
        dayTimeSingular:function(){
            let time = this.dayTime;
            if(!time){
                return "";
            }
            let current =  _.find(this.daytimeList, (item)=>{
                return time == item.state;
            })
            return current.plural;
        },
        wearimg:function(){
            return this.$store.getters.getWearImg;
        },
        dayTime:function(){
            return this.$store.getters.getDayTime;
        },
        places:function(){
            return this.$store.getters.getPlaces;
        },
        weather:function(){
            return this.$store.getters.getWeather;
        },
        wear:function(){
            return this.$store.getters.getWeat;
        },
        chunkPlaces:function(){
            let chunk = _.chunk(this.places, this.places.length / 2);
            return chunk;
        },
        chunkWear:function(){
            let chunk = _.chunk(this.wear, this.wear.length / 2);
            return chunk;
        },
        getClodAnim:function(){
            let speed = 12;
            return {
                "animation": "loading "+speed+"s infinite linear"
            }
        },
        getClodAnimP:function(){
            let speed = 20;
            
            return {
                "animation": "loading_paralax "+speed+"s infinite linear"
            }
        }
    },
    watch:{
        dayTime:function(){
            let map = {
                'morning': 1,
                'day': 2,
                'evening': 3,
                'night': 4,
            };
            let hour = DateTime.local().hour;
            let time = this.deyTimeByHour(hour);
            if(time != this.dayTime){
                let raz =  (map[this.dayTime] - map[time]) 
                if(raz<0){
                    hour = 24 + raz * 6;
                }else{
                    hour = raz * 6;
                }
            }else{
                hour = 0
            }
             
            this.$store.commit('loadData', hour);
        },
        wearimg:function(val, old){
            if(val != old){
                if(old){
                    let find = _.find(this.slidesWearing, (item)=>{
                        return item.wear == old;
                    });
                    find.show = false;
                }
                this.slidesWearing.push({
                    id: Math.random().toString(36).substr(2, 9),
                    wear: val,
                    show: true,
                });
                setTimeout(()=>{
                    _.remove(this.slidesWearing, {show:false})
                }, 800);
            }
        }
    },
    methods:{
        
        deyTimeByHour:function(hour){
            let daytime = 'morning';
            switch (true) {
                case hour >= 21 && hour < 24 || hour >= 0 && hour < 4:
                    daytime = 'night';
                    break;
                case hour >= 4  && hour < 10:
                    daytime = 'morning';
                    break;
                case hour >= 10   && hour < 16:
                    daytime = 'day';
                    break;
                case hour >= 16  && hour < 21:
                    daytime = 'evening';
                    break;
                }
            return daytime
        },
        openRoute:function(item){
            this.destenation = item;
            this.dialog = true;
        },
        drawerChange:function(){
            this.$store.commit('toogleDrawer');
        },
        selectTime:function(time){
            this.$store.commit('setDayTime', time);
        },
        getWindName:function(value){
            switch (true) {
                case value<4:
                    return 'Слабый ветер';
                    break;
            
                case value<10:
                    return 'Средний ветер';
                    break;

                case value<15:
                    return 'Резкий ветер';
                    break;
            }
        },
        getWindDesc:function(value){
            switch (true) {
                case value<4:
                    return 'Гоняет листья по земле';
                    break;
            
                case value<10:
                    return 'Берегитесь пыли!';
                    break;

                case value<15:
                    return 'Крепче держите шляпу!';
                    break;
            }
        }
    }
};
</script>
